/*
 * Licensed Materials - Property of IBM,
 *     Copyright IBM Corp. 2012  All Rights Reserved
 */
package java.lang.invoke;

class MethodHandleUtils {
	
         static boolean isCallerSensitive(Class<?> clazz, String methodName) {
                  
        switch (methodName) {
        case "doPrivileged":
            return clazz == java.security.AccessController.class;
        case "getUnsafe":
        	return clazz == sun.misc.Unsafe.class;
        case "lookup":
              return clazz == java.lang.invoke.MethodHandles.class;
        case "invoke":
            return clazz == java.lang.reflect.Method.class;

        case "get":
        case "getBoolean":
        case "getByte":
        case "getChar":
        case "getShort":
        case "getInt":
        case "getLong":
        case "getFloat":
        case "getDouble":
        case "set":
        case "setBoolean":
        case "setByte":
        case "setChar":
        case "setShort":
        case "setInt":
        case "setLong":
        case "setFloat":
        case "setDouble":
            return clazz == java.lang.reflect.Field.class;

        case "newInstance":
        
            if (clazz == java.lang.reflect.Constructor.class)  return true;
            if (clazz == java.lang.Class.class)  return true;
            break;
        case "forName":
        case "getClassLoader":
        case "getClasses":
        case "getFields":
        case "getMethods":
        case "getConstructors":
        case "getDeclaredClasses":
        case "getDeclaredFields":
        case "getDeclaredMethods":
        case "getDeclaredConstructors":
        case "getField":
        case "getMethod":
        case "getConstructor":
        case "getDeclaredField":
        case "getDeclaredMethod":
        case "getDeclaredConstructor":
            return clazz == java.lang.Class.class;

        case "getConnection":
        case "getDriver":
        case "getDrivers":
        case "deregisterDriver":
            return clazz == java.sql.DriverManager.class;
        case "newUpdater":
        	if (clazz == java.util.concurrent.atomic.AtomicIntegerFieldUpdater.class)  return true;
            if (clazz == java.util.concurrent.atomic.AtomicLongFieldUpdater.class)  return true;
            if (clazz == java.util.concurrent.atomic.AtomicReferenceFieldUpdater.class)  return true;
            break;
        case "getContextClassLoader":
            return clazz == java.lang.Thread.class;

        case "getPackage":
        case "getPackages":
            return clazz == java.lang.Package.class;

        case "getParent":
        case "getSystemClassLoader":
            return clazz == java.lang.ClassLoader.class;

        case "load":
        case "loadLibrary":

            if (clazz == java.lang.Runtime.class)  return true;
            if (clazz == java.lang.System.class)  return true;
            break;
        case "getCallerClass":
            if (clazz == sun.reflect.Reflection.class)  return true;
            if (clazz == java.lang.System.class)  return true;
            break;
        case "getCallerClassLoader":
            return clazz == java.lang.ClassLoader.class;

        case "getProxyClass":
        case "newProxyInstance":
            return clazz == java.lang.reflect.Proxy.class;

        case "getBundle":
        case "clearCache":
            return clazz == java.util.ResourceBundle.class;

        }
        return false;
    }

}
